#!/bin/zsh

declare -A _GET
declare -A _POST
declare -A _REF

cgi_get() {  # parse HTTP GET string
  echo "$QUERY_STRING" |tr '&' '\n' |while read query; do
    key="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\1:')"
    val="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\2:')"
    _GET["$key"]="$(echo -e "$(echo "$val" |sed 's:+: :g;s:%:\\x:g')")"
  done
}

cgi_post() {  # parse HTTP POST string
  sed -u 1q |tr '&' '\n' |while read query; do
    key="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\1:')"
    val="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\2:')"
    value="$(echo -e "$(echo "$val" |sed 's:+: :g;s:%:\\x:g')")"
    if [ -n "$_POST[\"$key\"]" ]; then
      n=0
      while [ -n "$_POST[\"$key$n\"]" ]; do n=$(($n + 1)); done
      _POST["$key$n"]="$value"
    else
      _POST["$key"]="$value"
    fi
  done
}

cgi_refdata() { # Parse GET data from referer
  echo "$HTTP_REFERER" |cut -d'?' -f2- |tr '&' '\n' |while read query; do
    key="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\1:')"
    val="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\2:')"
    _REF["$key"]="$(echo -e "$(echo "$val" |sed 's:+: :g;s:%:\\x:g')")"
  done
}
